
//
//  Spectro data definitions
//
//  Data generated by Faster MnM's : Trapezoid or CRRC4 Spectro modules (on Caras & Mosahr boards)
//


#ifndef SPECTRO_H
#define SPECTRO_H 1

#ifdef __cplusplus
extern "C" {
#endif


//  CONST

  typedef enum {
    CRRC4_SPECTRO_TYPE_ALIAS   = 61,   
    TRAPEZ_SPECTRO_TYPE_ALIAS  = 62, 
    SPECTRO_COUNTER_TYPE_ALIAS = 70
  } spectro_const;


//  DATA DEFINITIONS

  typedef struct crrc4_spectro {     //  from CRRC4_Spectro_Caras or CRRC4_Spectro_Mosahr
    unsigned pad1      : 10;
    signed   delta_t   : 16;
    unsigned pad2      :  6;
    signed   measure   : 22;
    unsigned pad3      :  8;
    unsigned saturated :  1;
    unsigned pileup    :  1;
  } crrc4_spectro;


  typedef struct trapez_spectro {    //  from Trapezoidal_Spectro_Caras or Trapezoidal_Spectro_Mosahr
    signed   measure   : 23;
    unsigned tdc       :  6;
    unsigned pileup    :  1;
    unsigned saturated :  1;
    unsigned sat_cpz   :  1;
  } trapez_spectro;
  

  typedef struct spectro_counter {   //  all kind of Spectro module
    unsigned calc : 32;
    unsigned sent : 32;
    unsigned trig : 32;
  } spectro_counter;



//  CONVERSION ACCESSORS

  double crrc4_spectro_delta_t_ns  (crrc4_spectro data);

  double trapez_spectro_conv_dt_ns (int tdc);

#ifdef __cplusplus
}
#endif

#endif  // SPECTRO_H


